package info.textgrid.middleware;

import java.util.ArrayList;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;
import java.util.UUID;
import org.classicmayan.tools.Queries;
import info.textgrid.middleware.oaipmh.ListIdentifiersType;
import info.textgrid.middleware.oaipmh.ResumptionTokenType;

/**
 *
 */
public class IdentifierListDelivererIDIOM extends IdentifierListDelivererAbstract {

  static Map<String, Integer> cursorCollector = new Hashtable<String, Integer>();

  /**
   * @param textgrid
   * @param dariah
   */
  public IdentifierListDelivererIDIOM(boolean textgrid, boolean dariah) {
    super(textgrid, dariah);
  }

  /*
   * (non-Javadoc)
   * 
   * @see info.textgrid.middleware.IdentifierListDelivererAbstract#processIdentifierList(java.lang.
   * String, java.lang.String, java.lang.String, java.lang.String)
   */
  public ListIdentifiersType processIdentifierList(final String from, final String to,
      final String set, final String resumptionToken) {

    String resTokenValue = resumptionToken;

    ListIdentifiersType identifierList = new ListIdentifiersType();
    List<String> artefactURIs = new ArrayList<String>();
    Queries queries = new Queries();
    if (resumptionToken == null) {
      artefactURIs = queries.getArtefactList(0);
      // Create resumption token for every request only (we do need the same token for resuming
      // because we are using a hash map for counting the calls).
      resTokenValue = UUID.randomUUID().toString();
    } else {
      // Use given resumption token here.
      artefactURIs = queries.getArtefactList(cursorCollector.get(resumptionToken));
    }

    long listSize = Queries.getAmountOfArtefacts();
    int i = 0;

    for (String artefactURI : artefactURIs) {
      RecordDelivererIDIOM idiomRecord = new RecordDelivererIDIOM(true, false);
      identifierList.getHeader()
          .add(idiomRecord.getRecordById(artefactURI).getRecord().getHeader());
      i++;
    }

    // Check the need for a resumption token!
    ResumptionTokenType resTokenForResponse = OAIPMHUtillities.getResumptionToken(listSize,
        resumptionToken, cursorCollector, resTokenValue, 30, i);

    if (resTokenForResponse != null) {
      identifierList.setResumptionToken(resTokenForResponse);
    }

    return identifierList;
  }

}
