package info.textgrid.middleware;

import java.util.ArrayList;
import java.util.List;
import info.textgrid.middleware.oaipmh.RequestType;

/**
 *
 */
public abstract class RecordListDelivererAbstract implements RecordListDelivererInterface {

  protected boolean textgrid;
  protected boolean dariah;

  /**
   * @param textgrid
   * @param dariah
   */
  public RecordListDelivererAbstract(boolean textgrid, boolean dariah) {
    this.textgrid = textgrid;
    this.dariah = dariah;
  }

  /**
   * @param request
   * @return
   */
  public static ErrorHandler requestChecker(RequestType request) {

    ErrorHandler result = new ErrorHandler();

    // Check if metadata prefix is existing and valid.
    if (request.getMetadataPrefix() != null
        && !request.getMetadataPrefix().equals(TGConstants.METADATA_DC_PREFIX)
        && !request.getMetadataPrefix().equals(TGConstants.METADATA_IDIOM_PREFIX)) {
      result.setError(TGConstants.OAI_METADATA_FORMAT_ERROR,
          "The value of the metadataPrefix: " + request.getMetadataPrefix()
              + " is not supported by the item identified by the value of: "
              + request.getIdentifier());
    }

    // Check if resumptionToken is invalid or existing.
    if (request.getResumptionToken() != null) {
      boolean restokDCExisting = RecordListDelivererIDIOM.cursorCollector != null
          && RecordListDelivererIDIOM.cursorCollector.containsKey(request.getResumptionToken());
      boolean restokIDIOMExisting = RecordListDelivererDC.cursorCollector != null
          && RecordListDelivererDC.cursorCollector.containsKey(request.getResumptionToken());
      if (restokDCExisting || restokIDIOMExisting) {
        result.setError(TGConstants.OAI_BAD_RESUMPTION_TOKEN, "The value of the "
            + request.getResumptionToken() + " argument is invalid or expired.");
      }
    }
    
    // Check if query to ElastisSearch responses with more then zero results
    if(true) {
    	
    }
    
    // Check params in general.
    List<String> errorValues = new ArrayList<String>();

    if (request.getResumptionToken() != null && request.getMetadataPrefix() != null) {
      errorValues.add("metadataPrefix");
    }
    if (request.getResumptionToken() == null && request.getMetadataPrefix() == null) {
      errorValues.add("metadataPrefix");
    }
    if (request.getIdentifier() != null) {
      errorValues.add("identifier");
    }
    if (errorValues.size() > 0) {
      result.setError(TGConstants.OAI_BAD_ARGUMENT, "The request includes illegal arguments "
          + "or is missing required arguments: " + errorValues);
    }

    

    return result;
  }

}
